/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.52 Revision 1.216
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.52 2004/11/26 01:49:05 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.216 2008/11/13 23:50:55 mpagano Exp $
4 4
5# kernel.eclass rewrite for a clean base regarding the 2.6 series of kernel 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
6# with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
7# 7#
8# Author: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
9# Copyright 2004 Gentoo Linux 9# Maintainer: kernel-misc@gentoo.org
10# 10#
11# Please direct your bugs to the current eclass maintainer :) 11# Please direct your bugs to the current eclass maintainer :)
12# thatll be: johnm
13 12
14# added functionality: 13# added functionality:
15# unipatch - a flexible, singular method to extract, add and remove patches. 14# unipatch - a flexible, singular method to extract, add and remove patches.
16 15
17# A Couple of env vars are available to effect behaviour of this eclass 16# A Couple of env vars are available to effect usage of this eclass
18# These are as follows: 17# These are as follows:
19# 18#
20# K_NOFIXINSTALL_PATH - some patches (wolk for example) dont like INSTALL_PATH 19# K_USEPV - When setting the EXTRAVERSION variable, it should
21# being fixed prior to patching. therefore having this 20# add PV to the end.
22# option set disables the command to change this. 21# this is useful for thigns like wolk. IE:
22# EXTRAVERSION would be something like : -wolk-4.19-r1
23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be 23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
24# automatically set within the kernel Makefile 24# automatically set within the kernel Makefile
25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the 25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the
26# first part of ${PN} in EXTRAVERSION 26# first part of ${PN} in EXTRAVERSION
27# K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28# anything based on ${PR}.
27# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources, 29# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
28# ck-sources, ac-sources) it will use PR (ie: -r5) 30# ck-sources, ac-sources) it will use PR (ie: -r5) as
29# as the patchset version and not use it as a true 31# the patchset version for
30# package revision 32# and not use it as a true package revision
31# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in 33# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
32# postinst and can be used to carry additional postinst 34# postinst and can be used to carry additional postinst
33# messages 35# messages
36# K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
34# K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's 37# K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
35# K_NODETECTVER - Dont try to detect_version in pkg_setup. we will 38# K_SYMLINK - if this is set, then forcably create symlink anyway
36# specify KV, OKV and EXTRAVERSION ourselves. 39#
40# K_DEFCONFIG - Allow specifying a different defconfig target.
41# If length zero, defaults to "defconfig".
42# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
43# combination of "base" and "extras"
44# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
45# A value of "5" would apply genpatches-2.6.12-5 to
46# my-sources-2.6.12.ebuild
47# K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
48
37# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which 49# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
38# can be supported by the headers ebuild 50# can be supported by the headers ebuild
51
39# UNIPATCH_LIST - space delimetered list of patches to be applied to the 52# UNIPATCH_LIST - space delimetered list of patches to be applied to the
40# kernel 53# kernel
41# UNIPATCH_EXCLUDE - an additional var to support exlusion based completely 54# UNIPATCH_EXCLUDE - an addition var to support exlusion based completely
42# on "<passedstring>*" and not "<passedno#>_*" 55# on "<passedstring>*" and not "<passedno#>_*"
43# - this should _NOT_ be used from the ebuild as this is 56# - this should _NOT_ be used from the ebuild as this is
44# reserved for end users passing excludes from the cli 57# reserved for end users passing excludes from the cli
45# UNIPATCH_DOCS - space delimemeted list of docs to be installed to the 58# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
46# doc dir 59# the doc dir
47# UNIPATCH_STRICTORDER - if this is set places patches into directories of 60# UNIPATCH_STRICTORDER - if this is set places patches into directories of
48# order, so they are applied in the order passed 61# order, so they are applied in the order passed
49 62
50ECLASS="kernel-2" 63inherit eutils toolchain-funcs versionator multilib
51INHERITED="$INHERITED $ECLASS"
52EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst 64EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst
53 65
54# to prevent errors if theres no sources in /usr/src 66# Added by Daniel Ostrow <dostrow@gentoo.org>
55# we set KV and re-set it later on as well. 67# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
56[ -z "${KV}" ] && KV=${PV} 68# I will remove it when I come up with something more reasonable.
69[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
57 70
71export CTARGET=${CTARGET:-${CHOST}}
72if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
73 export CTARGET=${CATEGORY/cross-}
74fi
75
58HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/" 76HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
59LICENSE="GPL-2" 77LICENSE="GPL-2"
60IUSE="${IUSE} build doc"
61SLOT="${KV}"
62 78
63# Grab kernel version from KV 79# No need to run scanelf/strip on kernel sources/headers (bug #134453).
64KV_MAJOR=$(echo ${KV} | cut -d. -f1) 80RESTRICT="binchecks strip"
65KV_MINOR=$(echo ${KV} | cut -d. -f2)
66KV_PATCH=$(echo ${KV} | cut -d. -f3-)
67KV_PATCH=${KV_PATCH/[-_]*/}
68 81
69# set LINUX_HOSTCFLAGS if not already set 82# set LINUX_HOSTCFLAGS if not already set
83[[ -z ${LINUX_HOSTCFLAGS} ]] && \
70[ -z "$LINUX_HOSTCFLAGS" ] && LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include" 84 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"
71 85
86# debugging functions
87#==============================================================
88# this function exists only to help debug kernel-2.eclass
89# if you are adding new functionality in, put a call to it
90# at the start of src_unpack, or during SRC_URI/dep generation.
91debug-print-kernel2-variables() {
92 debug-print "PVR: ${PVR}"
93 debug-print "CKV: ${CKV}"
94 debug-print "OKV: ${OKV}"
95 debug-print "KV: ${KV}"
96 debug-print "KV_FULL: ${KV_FULL}"
97 debug-print "RELEASETYPE: ${RELEASETYPE}"
98 debug-print "RELEASE: ${RELEASE}"
99 debug-print "UNIPATCH_LIST_DEFAULT: ${UNIPATCH_LIST_DEFAULT} "
100 debug-print "UNIPATCH_LIST_GENPATCHES: ${UNIPATCH_LIST_GENPATCHES} "
101 debug-print "UNIPATCH_LIST: ${UNIPATCH_LIST}"
102 debug-print "S: ${S}"
103 debug-print "KERNEL_URI: ${KERNEL_URI}"
104}
105
72#Eclass functions only from here onwards... 106#Eclass functions only from here onwards ...
73#============================================================== 107#==============================================================
108handle_genpatches() {
109 local tarball
110 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return -1
111
112 for i in ${K_WANT_GENPATCHES} ; do
113 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2"
114 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
115 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
116 done
117}
118
119detect_version() {
120 # this function will detect and set
121 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
122 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
123 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
124
125 if [[ -n ${KV_FULL} ]]; then
126 # we will set this for backwards compatibility.
127 KV=${KV_FULL}
128
129 # we know KV_FULL so lets stop here. but not without resetting S
130 S=${WORKDIR}/linux-${KV_FULL}
131 return
132 fi
133
134 # CKV is used as a comparison kernel version, which is used when
135 # PV doesnt reflect the genuine kernel version.
136 # this gets set to the portage style versioning. ie:
137 # CKV=2.6.11_rc4
138 CKV=${CKV:-${PV}}
139 OKV=${OKV:-${CKV}}
140 OKV=${OKV/_beta/-test}
141 OKV=${OKV/_rc/-rc}
142 OKV=${OKV/-r*}
143 OKV=${OKV/_p*}
144
145 KV_MAJOR=$(get_version_component_range 1 ${OKV})
146 KV_MINOR=$(get_version_component_range 2 ${OKV})
147 KV_PATCH=$(get_version_component_range 3 ${OKV})
148
149 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
150 KV_EXTRA=$(get_version_component_range 4- ${OKV})
151 KV_EXTRA=${KV_EXTRA/[-_]*}
152 else
153 KV_PATCH=$(get_version_component_range 3- ${OKV})
154 fi
155 KV_PATCH=${KV_PATCH/[-_]*}
156
157 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
158
159 RELEASE=${CKV/${OKV}}
160 RELEASE=${RELEASE/_beta}
161 RELEASE=${RELEASE/_rc/-rc}
162 RELEASE=${RELEASE/_pre/-pre}
163 kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
164 RELEASETYPE=${RELEASE//[0-9]}
165
166 # Now we know that RELEASE is the -rc/-git
167 # and RELEASETYPE is the same but with its numerics stripped
168 # we can work on better sorting EXTRAVERSION.
169 # first of all, we add the release
170 EXTRAVERSION="${RELEASE}"
171 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
172 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
173
174 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
175 if [[ -n "${K_NOUSEPR}" ]]; then
176 # Don't add anything based on PR to EXTRAVERSION
177 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
178 elif [[ -n ${K_PREPATCHED} ]]; then
179 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
180 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
181 elif [[ "${ETYPE}" = "sources" ]]; then
182 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
183 # For some sources we want to use the PV in the extra version
184 # This is because upstream releases with a completely different
185 # versioning scheme.
186 case ${PN/-*} in
187 wolk) K_USEPV=1;;
188 vserver) K_USEPV=1;;
189 esac
190
191 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
192 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
193 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
194 fi
195 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
196
197 # The only messing around which should actually effect this is for KV_EXTRA
198 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
199 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
200 if [[ -n ${KV_EXTRA} ]]; then
201 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
202 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/patch-${CKV}.bz2
203 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.tar.bz2"
204 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2"
205 fi
206
207 # We need to set this using OKV, but we need to set it before we do any
208 # messing around with OKV based on RELEASETYPE
209 KV_FULL=${OKV}${EXTRAVERSION}
210
211 # we will set this for backwards compatibility.
212 S=${WORKDIR}/linux-${KV_FULL}
213 KV=${KV_FULL}
214
215 # -rc-git pulls can be achieved by specifying CKV
216 # for example:
217 # CKV="2.6.11_rc3_pre2"
218 # will pull:
219 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2
220
221 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
222 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
223 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2
224 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
225 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
226 fi
227
228 if [[ ${RELEASETYPE} == -git ]]; then
229 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2
230 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
231 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
232 fi
233
234 if [[ ${RELEASETYPE} == -rc-git ]]; then
235 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
236 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
237 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2
238 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
239 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
240 fi
241
242 debug-print-kernel2-variables
243
244 handle_genpatches
245}
246
74kernel_is() { 247kernel_is() {
75 local RESULT 248 [[ -z ${OKV} ]] && detect_version
76 RESULT=1 249 local operator test value x=0 y=0 z=0
77 250
78 if [ -n "${1}" ] 251 case ${1} in
79 then 252 lt) operator="-lt"; shift;;
80 [ "${1}" = "${KV_MAJOR}" ] && RESULT=0 253 gt) operator="-gt"; shift;;
81 fi 254 le) operator="-le"; shift;;
82 255 ge) operator="-ge"; shift;;
83 if [ -n "${2}" ] 256 eq) operator="-eq"; shift;;
84 then 257 *) operator="-eq";;
85 RESULT=1 258 esac
86 [ "${2}" = "${KV_MINOR}" ] && RESULT=0 259
87 fi 260 for x in ${@}; do
88 261 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
89 if [ -n "${3}" ] 262 value="${value}${x}"
90 then 263 z=$((${z} + 1))
91 RESULT=1 264
92 [ "${3}" = "${KV_PATCH}" ] && RESULT=0 265 case ${z} in
93 fi 266 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
94 return ${RESULT} 267 test="${test}${KV_MAJOR}";;
268 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
269 test="${test}${KV_MINOR}";;
270 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
271 test="${test}${KV_PATCH}";;
272 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
273 esac
274 done
275
276 [ ${test} ${operator} ${value} ] && return 0 || return 1
95} 277}
96 278
97kernel_is_2_4() { 279kernel_is_2_4() {
98 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -eq 4 ] && return 0 || return 1 280 kernel_is 2 4
99} 281}
100 282
101kernel_is_2_6() { 283kernel_is_2_6() {
102 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -eq 5 -o ${KV_MINOR} -eq 6 ] && \ 284 kernel_is 2 6 || kernel_is 2 5
103 return 0 || return 1
104} 285}
105 286
106# Capture the sources type and set DEPENDs 287# Capture the sources type and set DEPENDs
107if [ "${ETYPE}" == "sources" ] 288if [[ ${ETYPE} == sources ]]; then
108then
109 # binutils version needed to avoid Athlon/PIII/SSE assembler bugs.
110 DEPEND="!build? ( sys-apps/sed 289 DEPEND="!build? ( sys-apps/sed
111 >=sys-devel/binutils-2.11.90.0.31 ) 290 >=sys-devel/binutils-2.11.90.0.31 )"
112 doc? ( !arm? ( !s390? ( app-text/docbook-sgml-utils ) ) )"
113
114 RDEPEND="${DEPEND}
115 !build? ( >=sys-libs/ncurses-5.2 291 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
116 dev-lang/perl 292 sys-devel/make )
117 sys-apps/module-init-tools 293 virtual/dev-manager"
118 sys-devel/make )" 294
119
120 [ $(kernel_is_2_4) $? == 0 ] && \
121 PROVIDE="virtual/linux-sources" || \ 295 PROVIDE="virtual/linux-sources"
122 PROVIDE="virtual/linux-sources virtual/alsa" 296 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa"
123 297
298 SLOT="${PVR}"
299 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR} linux kernel"
300 IUSE="symlink build"
124elif [ "${ETYPE}" == "headers" ] 301elif [[ ${ETYPE} == headers ]]; then
125then 302 DESCRIPTION="Linux system headers"
303
304 # Since we should NOT honour KBUILD_OUTPUT in headers
305 # lets unset it here.
306 unset KBUILD_OUTPUT
307
308 if [[ ${CTARGET} = ${CHOST} ]]; then
309 DEPEND="!virtual/os-headers"
126 PROVIDE="virtual/kernel virtual/os-headers" 310 PROVIDE="virtual/os-headers"
311 SLOT="0"
312 else
313 SLOT="${CTARGET}"
314 fi
127else 315else
128 eerror "Unknown ETYPE=\"${ETYPE}\", must be either \"sources\" or \"headers\"" 316 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
129 die 317 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
130fi 318fi
131 319
320# Cross-compile support functions
321#==============================================================
322kernel_header_destdir() {
323 [[ ${CTARGET} == ${CHOST} ]] \
324 && echo /usr/include \
325 || echo /usr/${CTARGET}/usr/include
326}
327
328cross_pre_c_headers() {
329 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
330}
331
332env_setup_xmakeopts() {
333 # Kernel ARCH != portage ARCH
334 export KARCH=$(tc-arch-kernel)
335
336 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
337 # variables properly or bad things happen !
338 xmakeopts="ARCH=${KARCH}"
339 if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
340 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
341 elif type -p ${CHOST}-ar > /dev/null ; then
342 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
343 fi
344 export xmakeopts
345}
346
132# Unpack functions 347# Unpack functions
133#============================================================== 348#==============================================================
134unpack_2_4() { 349unpack_2_4() {
135 cd ${S}
136 # this file is required for other things to build properly, 350 # this file is required for other things to build properly,
137 # so we autogenerate it 351 # so we autogenerate it
138 make mrproper || die "make mrproper died" 352 make -s mrproper ${xmakeopts} || die "make mrproper failed"
353 make -s symlinks ${xmakeopts} || die "make symlinks failed"
139 make include/linux/version.h || die "make include/linux/version.h failed" 354 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
140 echo ">>> version.h compiled successfully." 355 echo ">>> version.h compiled successfully."
141} 356}
142 357
358unpack_2_6() {
359 # this file is required for other things to build properly, so we
360 # autogenerate it ... generate a .config to keep version.h build from
361 # spitting out an annoying warning
362 make -s mrproper ${xmakeopts} 2>/dev/null \
363 || die "make mrproper failed"
364
365 # quick fix for bug #132152 which triggers when it cannot include linux
366 # headers (ie, we have not installed it yet)
367 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
368 touch .config
369 eerror "make defconfig failed."
370 eerror "assuming you dont have any headers installed yet and continuing"
371 epause 5
372 fi
373
374 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
375 || die "make include/linux/version.h failed"
376 rm -f .config >/dev/null
377}
378
143universal_unpack() { 379universal_unpack() {
144 [ -z "${OKV}" ] && OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
145
146 cd ${WORKDIR} 380 cd ${WORKDIR}
147
148 unpack linux-${OKV}.tar.bz2 381 unpack linux-${OKV}.tar.bz2
149 if [ "${OKV}" != "${KV}" ] 382 if [[ -d "linux" ]]; then
150 then
151 mv linux-${OKV} linux-${KV} || \ 383 mv linux linux-${KV_FULL} \
152 die "Unable to move source tree to ${KV}." 384 || die "Unable to move source tree to ${KV_FULL}."
385 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
386 mv linux-${OKV} linux-${KV_FULL} \
387 || die "Unable to move source tree to ${KV_FULL}."
153 fi 388 fi
154
155 # since pkg_setup sets S, and then portage resets S we
156 # need to re-set S= or it wont be correct.
157 S="${WORKDIR}/linux-${KV}"
158
159 cd ${S} 389 cd "${S}"
160 # change incorrect install path
161 [ -z "${K_NOFIXINSTALL_PATH}" ] && \
162 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
163 390
164 # remove all backup files 391 # remove all backup files
165 find . -iname "*~" -exec rm {} \; 2> /dev/null 392 find . -iname "*~" -exec rm {} \; 2> /dev/null
166 393
167 if [ -d "${S}/Documentation/DocBook" ] 394 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
395 # only do this for kernel < 2.6.27 since this file does not exist in later
396 # kernels
397 if [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
168 then 398 then
169 cd ${S}/Documentation/DocBook 399 sed -i \
170 sed -i -e "s:db2:docbook2:g" Makefile 400 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
171 cd ${S} 401 "${S}"/arch/ppc/Makefile
402 else
403 sed -i \
404 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
405 "${S}"/arch/powerpc/Makefile
172 fi 406 fi
173} 407}
174 408
175unpack_set_extraversion() { 409unpack_set_extraversion() {
176 cd ${S} 410 cd "${S}"
177 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile 411 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
412 cd "${OLDPWD}"
413}
414
415# Should be done after patches have been applied
416# Otherwise patches that modify the same area of Makefile will fail
417unpack_fix_install_path() {
418 cd "${S}"
419 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
178} 420}
179 421
180# Compile Functions 422# Compile Functions
181#============================================================== 423#==============================================================
182compile_headers() { 424compile_headers() {
183 local MY_ARCH 425 env_setup_xmakeopts
184 426
185 MY_ARCH=${ARCH} 427 # if we couldnt obtain HOSTCFLAGS from the Makefile,
186 unset ${ARCH} 428 # then set it to something sane
429 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
430 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
431
432 if kernel_is 2 4; then
187 yes "" | make oldconfig 433 yes "" | make oldconfig ${xmakeopts}
188 echo ">>> make oldconfig complete" 434 echo ">>> make oldconfig complete"
189 ARCH=${MY_ARCH} 435 make dep ${xmakeopts}
190} 436 elif kernel_is 2 6; then
437 # 2.6.18 introduces headers_install which means we dont need any
438 # of this crap anymore :D
439 kernel_is ge 2 6 18 && return 0
191 440
192compile_manpages() { 441 # autoconf.h isnt generated unless it already exists. plus, we have
193 local MY_ARCH 442 # no guarantee that any headers are installed on the system...
443 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
444 || touch include/linux/autoconf.h
194 445
195 einfo "Making manpages..." 446 # if K_DEFCONFIG isn't set, force to "defconfig"
196 MY_ARCH=${ARCH} 447 # needed by mips
197 unset ARCH 448 if [[ -z ${K_DEFCONFIG} ]]; then
198 make mandocs 449 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
199 ARCH=${MY_ARCH} 450 case ${CTARGET} in
451 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
452 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
453 *) K_DEFCONFIG="defconfig";;
454 esac
455 else
456 K_DEFCONFIG="defconfig"
457 fi
458 fi
459
460 # if there arent any installed headers, then there also isnt an asm
461 # symlink in /usr/include/, and make defconfig will fail, so we have
462 # to force an include path with $S.
463 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
464 ln -sf asm-${KARCH} "${S}"/include/asm
465 cross_pre_c_headers && return 0
466
467 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
468 if compile_headers_tweak_config ; then
469 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
470 fi
471 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
472 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
473 fi
474}
475
476compile_headers_tweak_config() {
477 # some targets can be very very picky, so let's finesse the
478 # .config based upon any info we may have
479 case ${CTARGET} in
480 sh*)
481 sed -i '/CONFIG_CPU_SH/d' .config
482 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
483 return 0;;
484 esac
485
486 # no changes, so lets do nothing
487 return 1
200} 488}
201 489
202# install functions 490# install functions
203#============================================================== 491#==============================================================
204install_universal() { 492install_universal() {
205 #fix silly permissions in tarball 493 #fix silly permissions in tarball
206 cd ${WORKDIR} 494 cd ${WORKDIR}
207 chown -R root:root * 495 chown -R root:0 *
208 chmod -R a+r-w+X,u+w * 496 chmod -R a+r-w+X,u+w *
497 cd ${OLDPWD}
209} 498}
210 499
211install_headers() { 500install_headers() {
212 [ $(kernel_is_2_4) $? == 0 ] && unpack_2_4 501 local ddir=$(kernel_header_destdir)
213 502
503 # 2.6.18 introduces headers_install which means we dont need any
504 # of this crap anymore :D
505 if kernel_is ge 2 6 18 ; then
506 env_setup_xmakeopts
507 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
508
509 # let other packages install some of these headers
510 rm -rf "${D}"/${ddir}/sound #alsa-headers
511 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
512 return 0
513 fi
514
515 # Do not use "linux/*" as that can cause problems with very long
516 # $S values where the cmdline to cp is too long
214 cd ${S} 517 cd "${S}"
215 dodir /usr/include/linux 518 dodir ${ddir}/linux
216 ln -sf ${S}/include/asm-${ARCH} ${S}/include/asm 519 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
217 cp -ax ${S}/include/linux/* ${D}/usr/include/linux
218 rm -rf ${D}/usr/include/linux/modules 520 rm -rf "${D}"/${ddir}/linux/modules
219 521
220 dodir /usr/include/asm 522 # Handle multilib headers and crap
221 cp -ax ${S}/include/asm/* ${D}/usr/include/asm 523 local multi_dirs="" multi_defs=""
222 524 case $(tc-arch-kernel) in
223 if [ $(kernel_is_2_6) $? == 0 ] 525 sparc64)
224 then 526 multi_dirs="sparc sparc64"
225 dodir /usr/include/asm-generic 527 multi_defs="!__arch64__ __arch64__"
528 ;;
529 x86_64)
530 multi_dirs="i386 x86_64"
531 multi_defs="__i386__ __x86_64__"
532 ;;
533 ppc64)
534 multi_dirs="ppc ppc64"
535 multi_defs="!__powerpc64__ __powerpc64__"
536 ;;
537 s390x)
538 multi_dirs="s390 s390x"
539 multi_defs="!__s390x__ __s390x__"
540 ;;
541 arm)
542 dodir ${ddir}/asm
543 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
544 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -sf arch-ebsa285 "${D}"/${ddir}/asm/arch
545 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -sf proc-armv "${D}"/${ddir}/asm/proc
546 ;;
547 powerpc)
548 dodir ${ddir}/asm
549 cp -pPR "${S}"/include/asm/* ${D}/${ddir}/asm
550 if [[ -e "${S}"/include/asm-ppc ]] ; then
551 dodir ${ddir}/asm-ppc
552 cp -pPR "${S}"/include/asm-ppc/* ${D}/${ddir}/asm-ppc
553 fi
554 ;;
555 *)
556 dodir ${ddir}/asm
557 cp -pPR "${S}"/include/asm/* ${D}/${ddir}/asm
558 ;;
559 esac
560 if [[ -n ${multi_dirs} ]] ; then
561 local d ml_inc=""
562 for d in ${multi_dirs} ; do
563 dodir ${ddir}/asm-${d}
564 cp -pPR "${S}"/include/asm-${d}/* ${D}/${ddir}/asm-${d}/ || die "cp asm-${d} failed"
565
566 ml_inc="${ml_inc} ${multi_defs%% *}:${ddir}/asm-${d}"
567 multi_defs=${multi_defs#* }
568 done
569 create_ml_includes ${ddir}/asm ${ml_inc}
570 fi
571
572 if kernel_is 2 6; then
573 dodir ${ddir}/asm-generic
226 cp -ax ${S}/include/asm-generic/* ${D}/usr/include/asm-generic 574 cp -pPR "${S}"/include/asm-generic/* ${D}/${ddir}/asm-generic
227 fi 575 fi
576
577 # clean up
578 find "${D}" -name '*.orig' -exec rm -f {} \;
579
580 cd ${OLDPWD}
228} 581}
229 582
230install_sources() { 583install_sources() {
231 local doc
232 local docs
233 local file 584 local file
234 585
235 cd ${S} 586 cd "${S}"
236 dodir /usr/src 587 dodir /usr/src
237 echo ">>> Copying sources..." 588 echo ">>> Copying sources ..."
589
238 file="$(find ${WORKDIR} -iname "docs" -type d)" 590 file="$(find ${WORKDIR} -iname "docs" -type d)"
239 if [ -n "${file}" ] 591 if [[ -n ${file} ]]; then
240 then
241 for file in $(find ${file} -type f) 592 for file in $(find ${file} -type f); do
242 do
243 echo "${file/*docs\//}" >> ${S}/patches.txt 593 echo "${file//*docs\/}" >> "${S}"/patches.txt
244 echo "=========================================" >> ${S}/patches.txt 594 echo "===================================================" >> "${S}"/patches.txt
245 cat ${file} >> ${S}/patches.txt 595 cat ${file} >> "${S}"/patches.txt
246 echo "=========================================" >> ${S}/patches.txt 596 echo "===================================================" >> "${S}"/patches.txt
247 echo "" >> ${S}/patches.txt 597 echo "" >> "${S}"/patches.txt
248 done 598 done
249 fi 599 fi
250 600
251 if [ ! -f ${S}/patches.txt ] 601 if [[ ! -f ${S}/patches.txt ]]; then
252 then
253 # patches.txt is empty so lets use our ChangeLog 602 # patches.txt is empty so lets use our ChangeLog
254 [ -f ${FILESDIR}/../ChangeLog ] && \ 603 [[ -f ${FILESDIR}/../ChangeLog ]] && \
255 echo "Please check the ebuild ChangeLog for more details." \ 604 echo "Please check the ebuild ChangeLog for more details." \
256 > ${S}/patches.txt 605 > "${S}"/patches.txt
257 fi 606 fi
258 607
259 for doc in ${UNIPATCH_DOCS}
260 do
261 [ -f ${doc} ] && docs="${docs} ${doc}"
262 done
263
264 if [ -f ${S}/patches.txt ]; then
265 docs="${docs} ${S}/patches.txt"
266 fi
267
268 if use doc && ! use arm && ! use s390; then
269 install_manpages
270 fi
271
272 dodoc ${docs}
273 mv ${WORKDIR}/linux* ${D}/usr/src 608 mv ${WORKDIR}/linux* ${D}/usr/src
274} 609}
275 610
276install_manpages() {
277 local MY_ARCH
278
279 ebegin "Installing manpages"
280 MY_ARCH=${ARCH}
281 unset ARCH
282 sed -i -e "s#/usr/local/man#${D}/usr/man#g" scripts/makeman
283 make installmandocs
284 eend $?
285 sed -i -e "s#${D}/usr/man#/usr/local/man#g" scripts/makeman
286 ARCH=${MY_ARCH}
287}
288
289# pkg_preinst functions 611# pkg_preinst functions
290#============================================================== 612#==============================================================
291preinst_headers() { 613preinst_headers() {
292 [ -L ${ROOT}usr/include/linux ] && rm ${ROOT}usr/include/linux 614 local ddir=$(kernel_header_destdir)
293 [ -L ${ROOT}usr/include/asm ] && rm ${ROOT}usr/include/asm 615 [[ -L ${ddir}/linux ]] && rm ${ddir}/linux
616 [[ -L ${ddir}/asm ]] && rm ${ddir}/asm
294} 617}
295 618
296# pkg_postinst functions 619# pkg_postinst functions
297#============================================================== 620#==============================================================
298postinst_sources() { 621postinst_sources() {
299 if [ ! -h ${ROOT}usr/src/linux ] 622 local MAKELINK=0
300 then 623
624 # if we have USE=symlink, then force K_SYMLINK=1
625 use symlink && K_SYMLINK=1
626
627 # if we are to forcably symlink, delete it if it already exists first.
628 if [[ ${K_SYMLINK} > 0 ]]; then
301 ln -sf ${ROOT}usr/src/linux-${KV} ${ROOT}usr/src/linux 629 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
630 MAKELINK=1
631 fi
632
633 # if the link doesnt exist, lets create it
634 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
635
636 if [[ ${MAKELINK} == 1 ]]; then
637 cd ${ROOT}usr/src
638 ln -sf linux-${KV_FULL} linux
639 cd ${OLDPWD}
302 fi 640 fi
303 641
304 # Don't forget to make directory for sysfs 642 # Don't forget to make directory for sysfs
305 [ ! -d "${ROOT}/sys" -a $(kernel_is_2_6) $? == 0 ] && mkdir /sys 643 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
306 644
307 echo 645 echo
308 einfo "After installing a new kernel of any version, it is important" 646 elog "If you are upgrading from a previous kernel, you may be interested"
309 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y" 647 elog "in the following document:"
310 einfo "created (X.Y is the first 2 parts of your new kernel version)" 648 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
311 echo 649 echo
312 einfo "For example, this kernel will require:" 650
313 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
314 echo
315
316 # if K_EXTRAEINFO is set then lets display it now 651 # if K_EXTRAEINFO is set then lets display it now
317 if [ -n "${K_EXTRAEINFO}" ] 652 if [[ -n ${K_EXTRAEINFO} ]]; then
318 then
319 echo ${K_EXTRAEINFO} | fmt | 653 echo ${K_EXTRAEINFO} | fmt |
320 while read -s ELINE 654 while read -s ELINE; do einfo "${ELINE}"; done
321 do 655 fi
322 einfo "${ELINE}"
323 done
324 656
657 # if K_EXTRAELOG is set then lets display it now
658 if [[ -n ${K_EXTRAELOG} ]]; then
659 echo ${K_EXTRAELOG} | fmt |
660 while read -s ELINE; do elog "${ELINE}"; done
661 fi
662
663 # if K_EXTRAEWARN is set then lets display it now
664 if [[ -n ${K_EXTRAEWARN} ]]; then
665 echo ${K_EXTRAEWARN} | fmt |
666 while read -s ELINE; do ewarn "${ELINE}"; done
667 fi
668
669 # optionally display security unsupported message
670 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
325 echo 671 echo
672 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
673 ewarn "This means that it is likely to be vulnerable to recent security issues."
674 ewarn "For specific information on why this kernel is unsupported, please read:"
675 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
326 fi 676 fi
327 677
328 # Show policy version, if this kernel has SELinux... 678 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
329 local secfile 679 KV_MAJOR=$(get_version_component_range 1 ${OKV})
330 secfile="${ROOT}usr/src/linux-${KV}/security/selinux/include/security.h" 680 KV_MINOR=$(get_version_component_range 2 ${OKV})
331 if use selinux && [ -f "$secfile" ] 681 KV_PATCH=$(get_version_component_range 3 ${OKV})
332 then 682 if [[ "$(tc-arch)" = "sparc" ]] \
333 local polver=$(awk '/POLICYDB_VERSION /{print $3}' $secfile) 683 && [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]]
334 einfo "The SELinux policy version of this kernel is $polver."
335 echo
336 fi
337
338 # if K_EXTRAEWARN is set then lets display it now
339 if [ -n "${K_EXTRAEWARN}" ]
340 then
341 echo ${K_EXTRAEWARN} | fmt |
342 while read -s ELINE
343 do
344 ewarn "${ELINE}"
345 done
346
347 echo
348 fi
349}
350
351postinst_headers() {
352 echo
353 einfo "Kernel headers are usually only used when recompiling glibc."
354 einfo "Following the installation of newer headers it is advised that"
355 einfo "you re-merge glibc as follows:"
356 einfo "# emerge glibc"
357 einfo "Failure to do so will cause glibc to not make use of newer"
358 einfo "features present in the updated kernel headers."
359 echo
360}
361
362# pkg_setup functions
363#==============================================================
364setup_headers() {
365 ARCH=$(uname -m | sed -e s/[i].86/i386/ -e s/x86/i386/ \
366 -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/ \
367 -e s/amd64/x86_64/)
368 [ "$ARCH" == "sparc" -a "$PROFILE_ARCH" == "sparc64" ] && ARCH="sparc64"
369
370 [ -z "${H_SUPPORTEDARCH}" ] && H_SUPPORTEDARCH="${PN/-*/}"
371 for i in ${H_SUPPORTEDARCH}
372 do
373 [ "${ARCH}" == "${i}" ] && H_ACCEPT_ARCH="yes"
374 done
375
376 if [ "${H_ACCEPT_ARCH}" != "yes" ]
377 then 684 then
378 echo 685 echo
686 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
687 elog "you now need to do"
688 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
689 elog "instead of just"
690 elog " make"
691 elog "to compile the kernel. For more information please browse to"
692 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
693 echo
694 fi
695}
696
697postinst_headers() {
698 elog "Kernel headers are usually only used when recompiling your system libc, as"
699 elog "such, following the installation of newer headers, it is advised that you"
700 elog "re-merge your system libc."
701 elog "Failure to do so will cause your system libc to not make use of newer"
702 elog "features present in the updated kernel headers."
703}
704
705# pkg_setup functions
706#==============================================================
707setup_headers() {
708 [[ -z ${H_SUPPORTEDARCH} ]] && H_SUPPORTEDARCH=${PN/-*/}
709 for i in ${H_SUPPORTEDARCH}; do
710 [[ $(tc-arch) == "${i}" ]] && H_ACCEPT_ARCH="yes"
711 done
712
713 if [[ ${H_ACCEPT_ARCH} != "yes" ]]; then
714 echo
379 eerror "This version of ${PN} does not support ${ARCH}." 715 eerror "This version of ${PN} does not support $(tc-arch)."
380 eerror "Please merge the appropriate sources, in most cases" 716 eerror "Please merge the appropriate sources, in most cases"
381 eerror "this will be ${ARCH}-headers." 717 eerror "(but not all) this will be called $(tc-arch)-headers."
382 die "incorrect headers" 718 die "Package unsupported for $(tc-arch)"
383 fi 719 fi
384} 720}
385 721
386# unipatch 722# unipatch
387#============================================================== 723#==============================================================
388unipatch() { 724unipatch() {
389 local i 725 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
390 local x 726 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG extglob_bak
391 local extention 727
392 local PIPE_CMD 728 # set to a standard locale to ensure sorts are ordered properly.
393 local UNIPATCH_DROP 729 myLC_ALL="${LC_ALL}"
394 local KPATCH_DIR 730 myLANG="${LANG}"
395 local PATCH_DEPTH 731 LC_ALL="C"
396 local ELINE 732 LANG=""
397 local STRICT_COUNT
398 local PATCH_LEVEL
399 733
400 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/" 734 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
401 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR} 735 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
402 736
403 # We're gonna need it when doing patches with a predefined patchlevel 737 # We're gonna need it when doing patches with a predefined patchlevel
738 extglob_bak=$(shopt -p extglob)
404 shopt -s extglob 739 shopt -s extglob
405 740
406 # This function will unpack all passed tarballs, add any passed patches, 741 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
407 # and remove any passed patchnumbers
408 # usage can be either via an env var or by params 742 # usage can be either via an env var or by params
409 [ -n "${@}" ] && UNIPATCH_LIST="${@} ${UNIPATCH_LIST}" 743 # although due to the nature we pass this within this eclass
744 # it shall be by param only.
745 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
746 UNIPATCH_LIST="${@}"
410 747
411 #unpack any passed tarballs 748 #unpack any passed tarballs
412 for i in ${UNIPATCH_LIST} 749 for i in ${UNIPATCH_LIST}; do
413 do
414 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ] 750 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
415 then
416 extention=${i/*./}
417 extention=${extention/:*/}
418 case ${extention} in
419 tbz2) PIPE_CMD="tar -xvjf";;
420 bz2) PIPE_CMD="tar -xvjf";;
421 tgz) PIPE_CMD="tar -xvzf";;
422 gz) PIPE_CMD="tar -xvzf";;
423 *) eerror "Unrecognized tarball compression"
424 die "Unrecognized tarball compression";;
425 esac
426
427 if [ -n "${UNIPATCH_STRICTORDER}" ] 751 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
428 then 752 unset z
429 STRICT_COUNT=$((${STRICT_COUNT} + 1)) 753 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
430 mkdir -p ${KPATCH_DIR}/${STRICT_COUNT}/ 754 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
431 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR}/${STRICT_COUNT}/ \ 755 do z="${z}0";
756 done
757 PATCH_ORDER="${z}${STRICT_COUNT}"
758
759 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
760 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
761 unpack ${i##*/}
432 1>/dev/null 762 popd >/dev/null
433 else 763 else
434 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR} 1>/dev/null 764 pushd "${KPATCH_DIR}" >/dev/null
765 unpack ${i##*/}
766 popd >/dev/null
435 fi 767 fi
436 768
437 if [ $? == 0 ]
438 then
439 einfo "${i/*\//} unpacked"
440 [ -n "$(echo ${i} | grep ':')" ] && \
441 echo ">>> Strict patch levels not currently supported for tarballed patchsets" 769 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
442 else
443 eerror "Failed to unpack ${i/:*/}"
444 die "unable to unpack patch tarball"
445 fi
446 else 770 else
447 extention=${i/*./} 771 extention=${i/*./}
448 extention=${extention/:*/} 772 extention=${extention/:*/}
449 PIPE_CMD="" 773 PIPE_CMD=""
450 case ${extention} in 774 case ${extention} in
458 782
459 PATCH_LEVEL=${i/*([^:])?(:)} 783 PATCH_LEVEL=${i/*([^:])?(:)}
460 i=${i/:*/} 784 i=${i/:*/}
461 x=${i/*\//} 785 x=${i/*\//}
462 x=${x/\.${extention}/} 786 x=${x/\.${extention}/}
463 787
464 if [ -n "${PIPE_CMD}" ] 788 if [ -n "${PIPE_CMD}" ]; then
465 then
466 if [ ! -r "${i}" ] 789 if [ ! -r "${i}" ]; then
467 then
468 echo 790 echo
469 eerror "FATAL: unable to locate:" 791 eerror "FATAL: unable to locate:"
470 eerror "${i}" 792 eerror "${i}"
471 eerror "for read-only. The file either has incorrect" 793 eerror "for read-only. The file either has incorrect permissions"
472 eerror "permissions or does not exist." 794 eerror "or does not exist."
473 die Unable to locate ${i} 795 die Unable to locate ${i}
474 fi 796 fi
475 797
476 if [ -n "${UNIPATCH_STRICTORDER}" ] 798 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
477 then 799 unset z
478 STRICT_COUNT=$((${STRICT_COUNT} + 1)) 800 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
801 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
802 do z="${z}0";
803 done
804 PATCH_ORDER="${z}${STRICT_COUNT}"
805
479 mkdir -p ${KPATCH_DIR}/${STRICT_COUNT}/ 806 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
480 $(${PIPE_CMD} ${i} > \ 807 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL})
481 ${KPATCH_DIR}/${STRICT_COUNT}/${x}.patch${PATCH_LEVEL})
482 else 808 else
483 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) 809 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL})
484 fi 810 fi
485 fi 811 fi
486 fi 812 fi
487 done 813 done
488 814
489 #populate KPATCH_DIRS so we know where to look to remove the excludes 815 #populate KPATCH_DIRS so we know where to look to remove the excludes
490 x=${KPATCH_DIR} 816 x=${KPATCH_DIR}
491 KPATCH_DIR="" 817 KPATCH_DIR=""
492 LC_ALL="C"
493 for i in $(find ${x} -type d | sort -n) 818 for i in $(find ${x} -type d | sort -n); do
494 do
495 KPATCH_DIR="${KPATCH_DIR} ${i}" 819 KPATCH_DIR="${KPATCH_DIR} ${i}"
496 done 820 done
497 821
498 #so now lets get rid of the patchno's we want to exclude 822 #so now lets get rid of the patchno's we want to exclude
499 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}" 823 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
500 for i in ${UNIPATCH_DROP} 824 for i in ${UNIPATCH_DROP}; do
501 do
502 einfo "Excluding Patch #${i}" 825 ebegin "Excluding Patch #${i}"
503 for x in ${KPATCH_DIR} 826 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done
504 do 827 eend $?
505 rm -f ${x}/${i}* 2>/dev/null
506 done
507 done 828 done
508 829
509 # and now, finally, we patch it :) 830 # and now, finally, we patch it :)
510 for x in ${KPATCH_DIR} 831 for x in ${KPATCH_DIR}; do
511 do
512 for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n) 832 for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n); do
513 do
514 unset PATCH_DEPTH
515
516 STDERR_T="${T}/${i/*\//}" 833 STDERR_T="${T}/${i/*\//}"
517 STDERR_T="${STDERR_T/.patch*/.err}" 834 STDERR_T="${STDERR_T/.patch*/.err}"
518 STDERR_T="${STDERR_T/.diff*/.err}"
519 835
520 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/} 836 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/}
521 [ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/} 837 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/}
522 838
523 if [ -z "${PATCH_DEPTH}" ]; then 839 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
524 PATCH_DEPTH=0
525 fi
526 840
527 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)" 841 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
528 while [ ${PATCH_DEPTH} -lt 5 ] 842 while [ ${PATCH_DEPTH} -lt 5 ]; do
529 do
530 echo "Attempting Dry-run:" >> ${STDERR_T} 843 echo "Attempting Dry-run:" >> ${STDERR_T}
531 echo "cmd: patch -p${PATCH_DEPTH} --dry-run -f < ${i}" >> ${STDERR_T} 844 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
532 echo "==========================================" >> ${STDERR_T} 845 echo "=======================================================" >> ${STDERR_T}
533 if [ $(patch -p${PATCH_DEPTH} --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ] 846 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
534 then
535 echo "Attempting patch:" > ${STDERR_T} 847 echo "Attempting patch:" > ${STDERR_T}
536 echo "cmd: patch -p${PATCH_DEPTH} -f < ${i}" >> ${STDERR_T} 848 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
537 echo "======================================" >> ${STDERR_T} 849 echo "=======================================================" >> ${STDERR_T}
538 if [ $(patch -p${PATCH_DEPTH} -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ] 850 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
539 then
540 eend 0 851 eend 0
541 rm ${STDERR_T} 852 rm ${STDERR_T}
542 break 853 break
543 else 854 else
544 eend 1 855 eend 1
545 eerror "Failed to apply patch ${i/*\//}" 856 eerror "Failed to apply patch ${i/*\//}"
546 eerror "Please attach ${STDERR_T} to any bug you post." 857 eerror "Please attach ${STDERR_T} to any bug you may post."
547 die "Failed to apply ${i/*\//}" 858 die "Failed to apply ${i/*\//}"
548 fi 859 fi
549 else 860 else
550 PATCH_DEPTH=$((${PATCH_DEPTH} + 1)) 861 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
551 fi 862 fi
552 done 863 done
553 if [ ${PATCH_DEPTH} -eq 5 ] 864 if [ ${PATCH_DEPTH} -eq 5 ]; then
554 then
555 eend 1 865 eend 1
556 eerror "Please attach ${STDERR_T} to any bug you post." 866 eerror "Please attach ${STDERR_T} to any bug you may post."
557 die "Unable to dry-run patch." 867 die "Unable to dry-run patch."
558 fi 868 fi
559 done 869 done
560 done 870 done
561 871
872 # This is a quick, and kind of nasty hack to deal with UNIPATCH_DOCS which
873 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite,
874 # which is why I'm not taking too much time over this.
875 local tmp
876 for i in ${UNIPATCH_DOCS}; do
877 tmp="${tmp} ${i//*\/}"
878 cp -f ${i} ${T}/
879 done
880 UNIPATCH_DOCS="${tmp}"
881
562 # clean up KPATCH_DIR's - fixes bug #53610 882 # clean up KPATCH_DIR's - fixes bug #53610
563 for x in ${KPATCH_DIR} 883 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
564 do
565 rm -Rf ${x}
566 done
567 unset LC_ALL
568}
569 884
570# custom functions 885 LC_ALL="${myLC_ALL}"
571#============================================================== 886 LANG="${myLANG}"
572detect_version() { 887 eval ${extglob_bak}
573 # this function will detect and set 888}
574 # OKV: Original Kernel Version (2.6.0/2.6.0-test11) 889
575 # KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1) 890# getfilevar accepts 2 vars as follows:
576 # EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1) 891# getfilevar <VARIABLE> <CONFIGFILE>
577 892# pulled from linux-info
578 [ -n "${DETECTED}" ] && return 893
579 894getfilevar() {
580 if [ -z "${OKV}" ]; 895 local workingdir basefname basedname xarch=$(tc-arch-kernel)
581 then 896
582 OKV=${PV/_beta/-test} 897 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then
583 OKV=${OKV/_rc/-rc} 898 echo -e "\n"
584 OKV=${OKV/_pre*/} 899 eerror "getfilevar requires 2 variables, with the second a valid file."
585 OKV=${OKV/-r*/} 900 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
586 fi
587
588 KV_MAJOR=$(echo ${OKV} | cut -d. -f1)
589 KV_MINOR=$(echo ${OKV} | cut -d. -f2)
590 KV_PATCH=$(echo ${OKV} | cut -d. -f3-)
591 KV_PATCH=${KV_PATCH/[-_]*/}
592
593 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
594
595 RELEASE=${PV/${OKV}/}
596 RELEASE=${RELEASE/_beta/}
597 RELEASE=${RELEASE/_rc/-rc}
598 if [ $(kernel_is_2_4) $? == 0 ]
599 then
600 RELEASE=${RELEASE/_pre/-pre}
601 else 901 else
602 RELEASE=${RELEASE/_pre/-bk} 902 workingdir=${PWD}
603 fi 903 basefname=$(basename ${2})
604 RELEASETYPE=${RELEASE//[0-9]/} 904 basedname=$(dirname ${2})
605 EXTRAVERSION="${RELEASE}" 905 unset ARCH
606 906
607 if [ -n "${K_PREPATCHED}" ] 907 cd ${basedname}
608 then 908 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
609 EXTRAVERSION="${EXTRAVERSION}-${PN/-*/}${PR/r/}" 909 make ${BUILD_FIXES} -s -f - e 2>/dev/null
610 else 910 cd ${workingdir}
611 [ -z "${K_NOUSENAME}" ] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*/}"
612 [ "${PN/-*/}" == "wolk" ] && EXTRAVERSION="-${PN/-*/}-${PV}"
613 [ "${PR}" != "r0" ] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
614 fi
615 911
616 # -rcXX-bkXX pulls are *IMPOSSIBLE* to support within the 912 ARCH=${xarch}
617 # portage naming convention these cannot be supported, but the code here can
618 # handle it up until this point and theoretically thereafter.
619
620 if [ "${RELEASETYPE}" == "-rc" -o "${RELEASETYPE}" == "-pre" ]
621 then
622 OKV="${KV_MAJOR}.${KV_MINOR}.$([ $((${KV_PATCH} - 1)) -lt 0 ] && \
623 echo ${KV_PATCH} || echo $((${KV_PATCH} - 1)))"
624 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${PV//_/-}.bz2
625 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
626 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${PV//_/-}.bz2"
627 KV=${PV/[-_]*/}${EXTRAVERSION}
628 fi 913 fi
629
630 if [ "${RELEASETYPE}" == "-bk" ]
631 then
632 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
633 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
634 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
635 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
636 KV=${PV/[-_]*/}${EXTRAVERSION}
637 fi
638
639 if [ "${RELEASETYPE}" == "-rc-bk" ]
640 then
641 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))-${RELEASE/-bk*}"
642 EXTRAVERSION="$([ -n "${RELEASE}" ] && echo ${RELEASE/*-bk/-bk})$([ -n "${K_USENAME}" ] && echo -${PN/-*/})$([ ! "${PR}" == "r0" ] && echo -${PR})"
643
644 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
645 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
646 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
647 KV=${PV/[-_]*/}${EXTRAVERSION}
648 fi
649
650 S=${WORKDIR}/linux-${KV}
651 DETECTED="yes"
652} 914}
653 915
654detect_arch() { 916detect_arch() {
655 # This function sets ARCH_URI and ARCH_PATCH 917 # This function sets ARCH_URI and ARCH_PATCH
656 # with the neccessary info for the arch sepecific compatibility 918 # with the neccessary info for the arch sepecific compatibility
657 # patchsets. 919 # patchsets.
658 920
659 local ALL_ARCH 921 local ALL_ARCH LOOP_ARCH COMPAT_URI i
660 local LOOP_ARCH
661 local COMPAT_URI
662 local i
663 922
664 # COMPAT_URI is the contents of ${ARCH}_URI 923 # COMPAT_URI is the contents of ${ARCH}_URI
665 # ARCH_URI is the URI for all the ${ARCH}_URI patches 924 # ARCH_URI is the URI for all the ${ARCH}_URI patches
666 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH 925 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
667 926
668 ARCH_URI="" 927 ARCH_URI=""
669 ARCH_PATCH="" 928 ARCH_PATCH=""
670 ALL_ARCH="X86 PPC PPC64 SPARC MIPS ALPHA ARM HPPA AMD64 IA64 X86OBSD S390" 929 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
671 930
672 for LOOP_ARCH in ${ALL_ARCH} 931 for LOOP_ARCH in ${ALL_ARCH}; do
673 do
674 COMPAT_URI="${LOOP_ARCH}_URI" 932 COMPAT_URI="${LOOP_ARCH}_URI"
675 COMPAT_URI="${!COMPAT_URI}" 933 COMPAT_URI="${!COMPAT_URI}"
676 934
677 [ -n "${COMPAT_URI}" ] && \ 935 [[ -n ${COMPAT_URI} ]] && \
678 ARCH_URI="${ARCH_URI} $(echo ${LOOP_ARCH} | tr [A-Z] [a-z])? ( ${COMPAT_URI} )" 936 ARCH_URI="${ARCH_URI} $(echo ${LOOP_ARCH} | tr '[:upper:]' '[:lower:]')? ( ${COMPAT_URI} )"
679 937
680 if [ "${LOOP_ARCH}" == "$(echo ${ARCH} | tr [a-z] [A-Z])" ] 938 if [[ ${LOOP_ARCH} == "$(echo $(tc-arch-kernel) | tr '[:lower:]' '[:upper:]')" ]]; then
681 then
682 for i in ${COMPAT_URI} 939 for i in ${COMPAT_URI}; do
683 do
684 ARCH_PATCH="${ARCH_PATCH} ${DISTDIR}/${i/*\//}" 940 ARCH_PATCH="${ARCH_PATCH} ${DISTDIR}/${i/*\//}"
685 done 941 done
686 fi 942 fi
687 done 943 done
688} 944}
689 945
946# sparc nastiness
947#==============================================================
948# This script generates the files in /usr/include/asm for sparc systems
949# during installation of sys-kernel/linux-headers.
950# Will no longer be needed when full 64 bit support is used on sparc64
951# systems.
952#
953# Shamefully ripped from Debian
954# ----------------------------------------------------------------------
955
956# Idea borrowed from RedHat's kernel package
957
958# This is gonna get replaced by something in multilib.eclass soon...
959# --eradicator
960generate_sparc_asm() {
961 local name
962
963 cd $1 || die
964 mkdir asm
965
966 for h in `( ls asm-sparc; ls asm-sparc64 ) | grep '\.h$' | sort -u`; do
967 name="$(echo $h | tr a-z. A-Z_)"
968 # common header
969 echo "/* All asm/ files are generated and point to the corresponding
970 * file in asm-sparc or asm-sparc64.
971 */
972
973#ifndef __SPARCSTUB__${name}__
974#define __SPARCSTUB__${name}__
975" > asm/${h}
976
977 # common for sparc and sparc64
978 if [ -f asm-sparc/$h -a -f asm-sparc64/$h ]; then
979 echo "#ifdef __arch64__
980#include <asm-sparc64/$h>
981#else
982#include <asm-sparc/$h>
983#endif
984" >> asm/${h}
985
986 # sparc only
987 elif [ -f asm-sparc/$h ]; then
988echo "#ifndef __arch64__
989#include <asm-sparc/$h>
990#endif
991" >> asm/${h}
992
993 # sparc64 only
994 else
995echo "#ifdef __arch64__
996#include <asm-sparc64/$h>
997#endif
998" >> asm/${h}
999 fi
1000
1001 # common footer
1002 echo "#endif /* !__SPARCSTUB__${name}__ */" >> asm/${h}
1003 done
1004 return 0
1005}
1006
1007headers___fix() {
1008 # Voodoo to partially fix broken upstream headers.
1009 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
1010 sed -i \
1011 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
1012 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
1013 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
1014 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
1015 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
1016 "$@"
1017}
690 1018
691# common functions 1019# common functions
692#============================================================== 1020#==============================================================
693kernel-2_src_unpack() { 1021kernel-2_src_unpack() {
694 universal_unpack 1022 universal_unpack
695 [ -n "${UNIPATCH_LIST}" -o -n "${UNIPATCH_LIST_DEFAULT}" ] && \ 1023 debug-print "Doing unipatch"
696 unipatch "${UNIPATCH_LIST_DEFAULT}" 1024
1025 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
1026 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
1027
1028 debug-print "Doing premake"
1029
1030 # allow ebuilds to massage the source tree after patching but before
1031 # we run misc `make` functions below
1032 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1033
1034 debug-print "Doing unpack_set_extraversion"
1035
697 [ -z "${K_NOSETEXTRAVERSION}" ] && unpack_set_extraversion 1036 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
698 [ $(kernel_is_2_4) $? == 0 ] && unpack_2_4 1037 unpack_fix_install_path
1038
1039 # Setup xmakeopts and cd into sourcetree.
1040 env_setup_xmakeopts
1041 cd "${S}"
1042
1043 # We dont need a version.h for anything other than headers
1044 # at least, I should hope we dont. If this causes problems
1045 # take out the if/fi block and inform me please.
1046 # unpack_2_6 should now be 2.6.17 safe anyways
1047 if [[ ${ETYPE} == headers ]]; then
1048 kernel_is 2 4 && unpack_2_4
1049 kernel_is 2 6 && unpack_2_6
1050 fi
699} 1051}
700 1052
701kernel-2_src_compile() { 1053kernel-2_src_compile() {
1054 cd "${S}"
702 [ "${ETYPE}" == "headers" ] && compile_headers 1055 [[ ${ETYPE} == headers ]] && compile_headers
703 [ "${ETYPE}" == "sources" ] && \
704 use doc && ! use arm && ! use s390 && compile_manpages
705} 1056}
706 1057
707kernel-2_pkg_preinst() { 1058kernel-2_pkg_preinst() {
708 [ "${ETYPE}" == "headers" ] && preinst_headers 1059 [[ ${ETYPE} == headers ]] && preinst_headers
709} 1060}
710 1061
711kernel-2_src_install() { 1062kernel-2_src_install() {
712 install_universal 1063 install_universal
713 [ "${ETYPE}" == "headers" ] && install_headers 1064 [[ ${ETYPE} == headers ]] && install_headers
714 [ "${ETYPE}" == "sources" ] && install_sources 1065 [[ ${ETYPE} == sources ]] && install_sources
715} 1066}
716 1067
717kernel-2_pkg_postinst() { 1068kernel-2_pkg_postinst() {
718 [ "${ETYPE}" == "headers" ] && postinst_headers 1069 [[ ${ETYPE} == headers ]] && postinst_headers
719 [ "${ETYPE}" == "sources" ] && postinst_sources 1070 [[ ${ETYPE} == sources ]] && postinst_sources
720} 1071}
721 1072
722kernel-2_pkg_setup() { 1073kernel-2_pkg_setup() {
1074 if kernel_is 2 4; then
1075 if [ "$( gcc-major-version )" -eq "4" ] ; then
1076 echo
1077 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1078 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1079 ewarn "newer kernel that supports gcc-4."
1080 echo
1081 ewarn "Also be aware that bugreports about gcc-4 not working"
1082 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1083 echo
1084 epause 10
1085 fi
1086 fi
1087
1088 ABI="${KERNEL_ABI}"
723 [ "${ETYPE}" == "headers" ] && setup_headers 1089 [[ ${ETYPE} == headers ]] && setup_headers
1090 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
724} 1091}

Legend:
Removed from v.1.52  
changed lines
  Added in v.1.216

  ViewVC Help
Powered by ViewVC 1.1.20